/*
  Calculate Molecular Weight and 
    Elemental Analysis

  copyright (c) by Ryo MIYAMOTO, 1998-1999
*/

#include "molwt.h"

int count(float *atoms, char token[NoOfToken][TokenLength], int ntoken)
{
  int i, n;
  float num=1;
  Boolean isFound;

  for (i=0; i<ntoken; i++) {
    if (isalpha(token[i][0])) {
      isFound=FALSE;
      for (n=1; n<=NoOfElements; n++) {
        if (strcmp(token[i], element[n].Symbol)==0) {
          isFound=TRUE;
          if (isdigit(token[i+1][0]) || token[i+1][0]=='.') {
            num=atof(token[i+1]);
            i++;
          } else {
            num=1;
          }
        } else if (Symbol2==TRUE && 
                   strcmp(token[i], element[n].Symbol2)==0) {
          isFound=TRUE;
          if (isdigit(token[i+1][0]) || token[i+1][0]=='.') {
            num=atof(token[i+1]);
            i++;
          } else {
            num=1;
          }
        }
        if (isFound==TRUE) {
          atoms[element[n].AtomNo]+=num;
          break;
	}
      }
      if (isFound==FALSE) {
        errorDialog();
	break;
      }
    } else {
      errorDialog();
      break;

      fprintf(stderr, "ERROR in chemical formula. (%d-th token)\n", i+1);
      usage(); /* error in chemical formula */
    }
  }

  return i;
}

void errorDialog(void)
{
#ifdef GTK
  GtkWidget *vbox, *okbutton, *action_area, *label;

  dialog=gtk_dialog_new();
  gtk_window_set_title(GTK_WINDOW(dialog), "Error Warning");
  gtk_window_set_policy(GTK_WINDOW(dialog), TRUE, TRUE, FALSE);
  gtk_signal_connect(GTK_OBJECT(dialog), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy), dialog);
  gtk_container_border_width(GTK_CONTAINER(dialog), 10);
  action_area=GTK_DIALOG(dialog)->action_area;
  vbox=GTK_DIALOG(dialog)->vbox;

  label=gtk_label_new("  ERROR: Check Chemical Formula  ");
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(vbox), label, TRUE, TRUE, 5);

  okbutton=gtk_button_new_with_label("OK");
  gtk_widget_show(okbutton);
  gtk_box_pack_start(GTK_BOX(action_area), okbutton, TRUE, TRUE, 10);
  GTK_WIDGET_SET_FLAGS(okbutton, GTK_CAN_DEFAULT);
  gtk_widget_grab_default(okbutton);
  gtk_signal_connect_object(GTK_OBJECT(okbutton), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dialog));

  gtk_widget_show(dialog);
  gtk_grab_add(GTK_WIDGET(dialog));
#else
  Widget cancelbutton, helpbutton;

  dialog=XmCreateWarningDialog(toplevel, "dialog", NULL, 0);
  cancelbutton=XmMessageBoxGetChild(dialog, XmDIALOG_CANCEL_BUTTON);
  XtUnmanageChild(cancelbutton);
  helpbutton=XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON);
  XtUnmanageChild(helpbutton);
  XtManageChild(dialog);
#endif
}
